<div id="body" class="container-fluid">
  <h5> Manage User Profiles </h5>
  <br />
      
  <form [formGroup]='usersForm'>
        
    <div class="row">
      <div class="col">
        <div class="card bg-light mb-5">
          <div class="card-body" style="height:120px;">
            <div>
              <table cellpadding="5" cellspacing="5">
                <tr>
                  <td>
                    <mat-form-field style="width:250px;">
                      <input type="text" placeholder="Search by Username or NTID" class="ng-trim-ignore" [formControl]="searchTerm" name="searchTerm" [matAutocomplete]="auto" matInput />
                      <!-- CREATE AUTO COMPLETE PANEL WITH OPTIONS. -->
                      <mat-autocomplete #auto="matAutocomplete">
                        <mat-option *ngFor="let user of searchUsers" [value]="user.fullNme + ' | ' + user.userAdid">
                          <span> {{ user.fullNme }}</span>
                          <small> | ID: {{user.userAdid}}</small>
                        </mat-option>
                      </mat-autocomplete>
                    </mat-form-field>
                  </td>
                  <td>
                    <button class="btn btn-sm btn-primary btn-block" style="width:170px; height:auto" type="button"
                            [disabled]="searchUsers.length === 0"
                            (click)="searchUser(searchUsers[0]?.userId)">
                      Search
                    </button>
                  </td>
                </tr>
              </table>
            </div>
          </div>
        </div>
      </div>


      <div class="col">
        <div class="card bg-light mb-5">
          <div class="card-body" style="height:120px;">
            <label>Add New User</label>
            <div>
              <table cellpadding="5" cellspacing="5">
                <tr>
                  <td>
                    <input type="text" style="width:260px;" class="form-control form-control-sm ng-trim-ignore" name="userAdid" [formControl]="userAdid" placeholder="NTID" size="20" />
                  </td>
                  <td>
                    <button class="btn btn-sm btn-primary btn-block" style="width:170px; height:auto" type="button"
                            (click)="AddUser(userAdid.value)">
                      Add
                    </button>
                  </td>
                </tr>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
  </form>

  <mat-expansion-panel [expanded]="true" class="mb-2" *ngIf="selectedUserProfile.length > 0">
    <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
      <mat-panel-title><h6>Update User</h6></mat-panel-title>
    </mat-expansion-panel-header>
    <div class="form-row" [style.visibility]="selectedUserProfile.length > 0 ? 'visible' : 'hidden'">
      <div class="col">
        <div class="form-row text-center m-1">
            <div class="form-group form-group-sm col-12 col-md-6 col-lg-5"> <br/>
              <button class="btn btn-sm btn-primary btn-block"  type="button"
                (click)="updateUserProfile(selectedUserProfile)">
                Update
              </button>
            </div>
            <div class="form-group form-group-sm col-12 col-md-6 col-lg-5"> <br/>
              <button class="btn btn-sm btn-secondary btn-block"  type="button"
                (click)="cancel()">
                Cancel
              </button>
            </div>
          </div>
        <br /><br />
        <div>
          <dx-data-grid #gridContainer id="gridContainer" [dataSource]="selectedUserProfile" keyExpr="usrPrfId"
                        [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                        [wordWrapEnabled]="true">
            <dxo-load-panel [enabled]="false"></dxo-load-panel>
            <dxo-scrolling mode="infinite"></dxo-scrolling>
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxi-column dataField="usrPrfDes" caption="Profile"></dxi-column>
            <dxi-column dataField="recStusId" [width]="100" [allowFiltering]="false"
                        [allowSorting]="false" cellTemplate="cellTemplaterecStus" caption="Access" alignment="center"></dxi-column>
            <dxi-column dataField="poolCd" [width]="100" [allowFiltering]="false" [visible]="isPooled"
                        [allowSorting]="false" cellTemplate="cellTemplatepoolCd" caption="Pooled" alignment="center"></dxi-column>

            <div *dxTemplate="let data of 'cellTemplaterecStus'">
              <div *ngIf="data.value === 2">
                <input type="checkbox" [(ngModel)]="data.value" disabled (ngModelChange)="onClick($event, data)" />
              </div>
              <div *ngIf="data.value != 2">
                <input type="checkbox" [(ngModel)]="data.value" (ngModelChange)="onClick($event, data)" />
              </div>
            </div>
            <div *dxTemplate="let data of 'cellTemplatepoolCd'">
              <div *ngIf="data.value === 2">
                <input type="checkbox" [(ngModel)]="data.value" disabled (ngModelChange)="onClick($event, data)" />
              </div>
              <div *ngIf="data.value != 2 && data.value != null">
                <input type="checkbox" [(ngModel)]="data.value" (ngModelChange)="onPoolCdClick($event, data)" />
              </div>
            </div>
          </dx-data-grid>
        </div>
      </div>
      <div class="col">
        <div class="row">            
              <div class="col">
                <label style="font-weight:bold;">NTID: </label>
              </div>
              <div class="col">
                <label>{{userData.userAdid}}</label>
              </div>
            </div>
            <div class="row">
              <div class="col">
                <label style="font-weight:bold;">Full Name: </label>
              </div>
              <div class="col">
                <label>{{userData.dsplNme}}</label>
              </div>
            </div>
  
            <div class="row">
              <div class="col">
                <label style="font-weight:bold;">Status: </label>
              </div>
              <div class="col">
                <!--<label><input type="checkbox" [(ngModel)]="userData.recStusId" (ngModelChange)="statusSelectionChange($event)" /> (Checked=Active; UnChecked=OnVacation or Inactive) </label>-->
                <label><input type="checkbox" [(ngModel)]="status" /> (Checked=Active; UnChecked=OnVacation or Inactive) </label>
              </div>
            </div>
  
            <div class="row">
              <div class="col">
                <label style="font-weight:bold;">Manager: </label>
              </div>
              <div class="col">
                <mat-form-field>
                  <mat-select placeholder="Please select Manager" [(value)]="userData.mgrAdid" (selectionChange)="managerSelectionChange($event)">
                    <mat-option *ngFor="let user of managerList" [value]="user.userAdid">
                      {{ user.fullNme }}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
              </div>
            </div>
  
            <div class="row" *ngIf="displayAutoAssignment">
              <div class="col">
                <label style="font-weight:bold;">Assignment Type: </label>
              </div>
              <div class="col">
                <mat-form-field>
                  <mat-select matNativeControl [(value)]="oldAutoAssignment" (selectionChange)="assignmentSelectionChange($event)">
                    <mat-option *ngFor="let option of assignmentTypeOptions" [value]="option.id">
                      {{ option.name }}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
              </div>
            </div>
            <div class="row">
              <div class="col">
                <label style="font-weight:bold;">CSG Level: </label>
              </div>
              <div class="col">
                <span> {{ csgLevel }}</span>
              </div>
            </div>

  
            <div class="row">
              <div class="col">
                <h6>{{lblAssignment}}</h6>
  
  
                <div class="form-group" *ngIf="wfmUserAssignmentsList.length > 0">
                  <button class="btn btn-sm btn-primary btn-block" style="width:185px; height:auto" type="button"
                          [disabled]="selectedAssignmentKeys === ''"
                          (click)="deleteAssignments()">
                    Remove Selected Records
                  </button>
                  <br /><br />
                  <div>
                    <dx-data-grid id="gridContainer1" [dataSource]="wfmUserAssignmentsList" keyExpr="wfmId"
                                  [rowAlternationEnabled]="true" [showBorders]="true" [wordWrapEnabled]="true"
                                  [columnAutoWidth]="true" (onSelectionChanged)="wfmAssignmentsSelectionChangedHandler($event)">
                      <dxo-load-panel [enabled]="false"></dxo-load-panel>
                      <dxo-scrolling mode="infinite"></dxo-scrolling>
                      <dxo-sorting mode="multiple"></dxo-sorting>
                      <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
                      <dxo-header-filter [visible]="true"></dxo-header-filter>
                      <!--<dxi-column dataField="ordrTypeDes" caption="Order Type" dataType="string"></dxi-column>-->
                      <dxi-column dataField="ordrActnDes" caption="Order Action" dataType="string"></dxi-column>
                      <dxi-column dataField="prodTypeDes" caption="Product Type" dataType="string"></dxi-column>
                      <dxi-column dataField="pltfrmNme" caption="Platform" dataType="string"></dxi-column>
                      <dxi-column dataField="orgtngCtryNme" caption="Originating Country" dataType="string" [visible]="isCountryColumnVisible"></dxi-column>
                      <!--<dxi-column dataField="iplTrmtgCtryNme" caption="Terminating Country" dataType="string"></dxi-column>-->
                    </dx-data-grid>
                  </div>
                </div>
                <!--<div class="row">
        <div class="col">
        </div>
        <div class="col">
        </div>
      </div>-->

  
                <div class="row">
                  <div class="col" *ngIf="orderActionList.length > 0">
                    <div class="form-group">
                      <h6>Order Action:</h6>
                      <div>
                        <dx-data-grid #grid id="gridContainer1" [dataSource]="orderActionList" keyExpr="ordrActnId"
                                      [rowAlternationEnabled]="true" [showBorders]="true" [wordWrapEnabled]="true"
                                      [columnAutoWidth]="true" (onSelectionChanged)="orderActionSelectionChangedHandler($event)">
                          <dxo-sorting mode="multiple"></dxo-sorting>
                          <dxo-load-panel [enabled]="false"></dxo-load-panel>
                          <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
                          <dxi-column dataField="ordrActnDes" caption="Order Action" dataType="string"></dxi-column>
                        </dx-data-grid>
                      </div>
                    </div>
                  </div>
                  <div class="col" *ngIf="prodPlatCombinedList.length > 0">
                    <div class="form-group">
                      <h6>Product Type/Platform:</h6>
                      <div>
                        <dx-data-grid #grid id="gridContainer1" [dataSource]="prodPlatCombinedList" keyExpr="prodTypeId"
                                      [rowAlternationEnabled]="true" [showBorders]="true" [wordWrapEnabled]="true"
                                      [columnAutoWidth]="true" (onSelectionChanged)="prodPlatCombSelectionChangedHandler($event)">
                          <dxo-sorting mode="multiple"></dxo-sorting>
                          <dxo-paging [enabled]="false"></dxo-paging>
                          <dxo-load-panel [enabled]="false"></dxo-load-panel>
                          <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
                          <dxi-column dataField="prodNme" caption="Product/Platform" dataType="string"></dxi-column>
                        </dx-data-grid>
                      </div>
                    </div>
                  </div>
                  <div class="col" *ngIf="originatingCountryList.length > 0">
                    <div class="form-group">
                      <h6>Originating Country:</h6>
                      <div>
                        <dx-data-grid #grid id="gridContainer1" [dataSource]="originatingCountryList" keyExpr="ctryCd"
                                      [rowAlternationEnabled]="true" [showBorders]="true" [wordWrapEnabled]="true"
                                      [columnAutoWidth]="true" (onSelectionChanged)="originatingCountrySelectionChangedHandler($event)">
                          <dxo-sorting mode="multiple"></dxo-sorting>
                          <dxo-paging [enabled]="false"></dxo-paging>
                          <dxo-load-panel [enabled]="false"></dxo-load-panel>
                          <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
                          <dxi-column dataField="ctryNme" caption="Country" dataType="string"></dxi-column>
                        </dx-data-grid>
                      </div>
                    </div>
                  </div>
                </div>
  
              </div>
            </div>
          </div>
            
    </div>
  </mat-expansion-panel>


</div>
